Attribute VB_Name = "modFileDir"
'**************************************************************
'**modFileDir
'**(c) 1995-1999, Shadow Mountain Tech. All rights reserved.
'**
'**This module contains standard functions for dealing with files
'**  and disk drives.
'**
'**Created by Don Lammers
'**
'**************************************************************

Option Explicit

Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long
    fState As Long
    wID As Long
    hSubMenu As Long
    hbmpChecked As Long
    hbmpUnchecked As Long
    dwItemData As Long
    dwTypeData As String
    cch As Long
End Type

Declare Function GetMenu Lib "user32" (ByVal hWnd As Long) As Long
Declare Function GetMenuCheckMarkDimensions Lib "user32" () As Long
Declare Function GetMenuContextHelpId Lib "user32" (ByVal hMenu As Long) As Long
Declare Function GetMenuDefaultItem Lib "user32" (ByVal hMenu As Long, ByVal fByPos As Long, ByVal gmdiFlags As Long) As Long
Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Declare Function GetMenuItemInfo Lib "user32" Alias "GetMenuItemInfoA" (ByVal hMenu As Long, ByVal un As Long, ByVal b As Boolean, lpMenuItemInfo As MENUITEMINFO) As Long
Declare Function GetMenuItemRect Lib "user32" (ByVal hWnd As Long, ByVal hMenu As Long, ByVal uItem As Long, lprcItem As RECT) As Long
Declare Function GetMenuState Lib "user32" (ByVal hMenu As Long, ByVal wID As Long, ByVal wFlags As Long) As Long
Declare Function GetMenuString Lib "user32" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Declare Function EnableMenuItem Lib "user32" (ByVal hMenu As Long, ByVal wIDEnableItem As Long, ByVal wEnable As Long) As Long
Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, ByVal nPos As Long) As Long
Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Declare Function IsMenu Lib "user32" (ByVal hMenu As Long) As Long


Public Const MF_BYCOMMAND = &H0&
Public Const MF_BYPOSITION = &H400&
Public Const MF_CALLBACKS = &H8000000
Public Const MF_CHANGE = &H80&
Public Const MF_CHECKED = &H8&
Public Const MF_CONV = &H40000000
Public Const MF_DELETE = &H200&
Public Const MF_DISABLED = &H2&
Public Const MF_ENABLED = &H0&
Public Const MF_END = &H80
Public Const MF_ERRORS = &H10000000
Public Const MF_GRAYED = &H1&
Public Const MF_HELP = &H4000&
Public Const MF_HILITE = &H80&
Public Const MF_HSZ_INFO = &H1000000
Public Const MF_INSERT = &H0&
Public Const MF_LINKS = &H20000000
Public Const MF_MASK = &HFF000000
Public Const MF_MENUBARBREAK = &H20&
Public Const MF_MENUBREAK = &H40&
Public Const MF_MOUSESELECT = &H8000&
Public Const MF_OWNERDRAW = &H100&
Public Const MF_POPUP = &H10&
Public Const MF_POSTMSGS = &H4000000
Public Const MF_REMOVE = &H1000&
Public Const MF_SENDMSGS = &H2000000
Public Const MF_SEPARATOR = &H800&
Public Const MF_STRING = &H0&
Public Const MF_SYSMENU = &H2000&
Public Const MF_UNCHECKED = &H0&
Public Const MF_UNHILITE = &H0&
Public Const MF_USECHECKBITMAPS = &H200&

'**Functions for executing programs****************************
Declare Function WinExec Lib "kernel32" (ByVal lpCmdLine As String, ByVal nCmdShow As Long) As Long
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal wHwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

'**Declare Windows API Functions*******************************
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Declare Function WriteProfileString Lib "kernel32" Alias "WriteProfileStringA" (ByVal lpszSection As String, ByVal lpszKeyName As String, ByVal lpszString As String) As Long
Declare Function WriteProfileSection Lib "kernel32" Alias "WriteProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String) As Long

Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, lpFileSystemNameBuffer As Any, ByVal nFileSystemNameSize As Long) As Long

'**GetDriveType & flags
Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Public Const DRIVE_UNKNOWN = 0
Public Const DRIVE_NO_ROOT_DIR = 1
Public Const DRIVE_REMOVABLE = 2
Public Const DRIVE_FIXED = 3
Public Const DRIVE_REMOTE = 4
Public Const DRIVE_CDROM = 5
Public Const DRIVE_RAMDISK = 6

'**File version information functions**************************
Declare Function GetFileVersionInfo Lib "version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwHandle As Long, ByVal dwLen As Long, lpData As Any) As Long
Declare Function GetFileVersionInfoSize Lib "version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Declare Function VerQueryValue Lib "version.dll" (pBlock As Any, ByVal lpSubBlock As String, ByVal lplpBuffer As Long, puLen As Long) As Long
Type VS_FIXEDFILEINFO
        dwSignature As Long
        dwStrucVersion As Long         '  e.g. 0x00000042 = "0.42"
        dwFileVersionMS As Long        '  e.g. 0x00030075 = "3.75"
        dwFileVersionLS As Long        '  e.g. 0x00000031 = "0.31"
        dwProductVersionMS As Long     '  e.g. 0x00030010 = "3.10"
        dwProductVersionLS As Long     '  e.g. 0x00000031 = "0.31"
        dwFileFlagsMask As Long        '  = 0x3F for version "0.42"
        dwFileFlags As Long            '  e.g. VFF_DEBUG Or VFF_PRERELEASE
        dwFileOS As Long               '  e.g. VOS_DOS_WINDOWS16
        dwFileType As Long             '  e.g. VFT_DRIVER
        dwFileSubtype As Long          '  e.g. VFT2_DRV_KEYBOARD
        dwFileDateMS As Long           '  e.g. 0
        dwFileDateLS As Long           '  e.g. 0
End Type

'**Get device capabilities**************************************
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long

'**GetDeviceCaps constants
Public Const NUMBRUSHES = 16
Public Const NUMCOLORS = 24
Public Const NUMFONTS = 22
Public Const NUMPENS = 18

'**SetErrorMode & flags************************************************
Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long
Public Const SEM_FAILCRITICALERRORS = &H1
Public Const SEM_NOGPFAULTERRORBOX = &H2
Public Const SEM_NOALIGNMENTFAULTEXCEPT = &H4
Public Const SEM_NOOPENFILEERRORBOX = &H8000

Function AddFile$(ByVal thisPath$, ByVal thisFile$)

If Left$(thisFile$, 1) = "\" And Len(thisFile$) > 1 Then
    thisFile$ = Mid$(thisFile$, 2)
ElseIf thisFile$ = "\" Then
    thisFile$ = ""
End If

If thisPath$ = "" Then
    AddFile$ = thisFile$
ElseIf Right$(thisPath$, 1) = "\" Then
    AddFile$ = thisPath$ + thisFile$
Else
    AddFile$ = thisPath$ + "\" + thisFile$
End If

End Function

Function ChangeFileExtension$(szFileName As String, szNewExtension As String, bPreservePath As Integer)
'******************************************************************
'**This function changes the file extension (if any) of szFilename param
'**to szNewExtension param.
'**If the file does not have an extension, it is added.
'**The full path is preserve if requested by the bPreservePath param.
'******************************************************************

Dim nTemp, nPos, nStart, nExtension As Integer
Dim szOutput As String

'**Make sure we have a file name as the first parameter
If Right$(szFileName, 1) = "\" Then
    '**The first parameter is a path without a file name.
    MsgBox "A call to ChangeFileExtension includes a path without a file name for the first parameter (" & szFileName & "). Something will probably not work properly, since a blank file name will be returned."
    Exit Function
End If

'Make sure that the extension has a dot****************************
If Left$(szNewExtension, 1) <> "." Then szNewExtension = "." & szNewExtension

nTemp = 1
'**Strip current extension from file name**************************
If InStr(1, szFileName, ".") = 0 Then
    '**The file has no extension
    nExtension = 0
    szOutput = szFileName
Else
    'Find the position of the last backslash. We already know that
    '**there is at least one dot in this file name.
    nExtension = 1
    Do
        nPos = InStr(nTemp, szFileName, "\")
        If nPos > 0 Then nTemp = nPos + 1
    Loop Until nPos = 0
    
    nStart = nTemp  'The position of the last slash + 1.
    
    'Now find the position of the last dot
    Do
        nPos = InStr(nTemp, szFileName, ".")
        If nPos > 0 Then nTemp = nPos + 1
    Loop Until nPos = 0
    '**Chop off the extension.
    '**At this point, nTemp is location of the last dot plus 1.
    szOutput = Left$(szFileName, nTemp - 2) 'The file name without the last dot or extension.
End If

'Preserve the path if requested
If bPreservePath Then nStart = 1  'Set start to first character of output string.

'Create the requested string and return.
ChangeFileExtension$ = Mid$(szOutput, nStart) & szNewExtension

End Function

Function IsDirectory(ByVal thisDir$)
Dim oldErrorMode&
Dim oldDir$
oldDir$ = CurDir$

oldErrorMode& = SetErrorMode(SEM_FAILCRITICALERRORS)
On Error Resume Next
ChDir$ thisDir$
'firstFile$ = Dir$(AddFile$(thisDir$, "*.*"))
Select Case Err
Case 0
    '**No error. the directory is there
    ChDir$ oldDir$
    IsDirectory = 1
Case Else
    '**Error. No directory or no files in directory.
    IsDirectory = 0
End Select
oldErrorMode& = SetErrorMode(oldErrorMode&)
On Error GoTo 0

End Function

Function CheckFile(ByVal thisFile$)
    'See if ThisFile$ is a legal file name

    CheckFile = False
    thisFile$ = GetFileOnly$(thisFile$)

    If thisFile$ = "" Then Exit Function
    If InStr(1, thisFile$, "*") Then Exit Function
    If InStr(1, thisFile$, "?") Then Exit Function
    If InStr(1, thisFile$, ":") Then Exit Function
    If InStr(1, thisFile$, "\") Then Exit Function
    If InStr(1, thisFile$, "/") Then Exit Function
   
    CheckFile = True

End Function

Function IsFile(ByVal thisFile$)

If IsDirectory(GetPathOnly$(thisFile$)) Then
    If Dir$(thisFile$) <> "" Then
        IsFile = 1
    Else
        IsFile = 0
    End If
Else
    IsFile = 0
End If

End Function

Function GetFileOnly$(ByVal thisFile$)
Dim thisSlash As Integer
Dim lastSlash As Integer
Dim lastBackslash As Integer
Dim thisPath$

'**Path only*******************************************
If Right$(thisFile$, 1) = "\" Or Right$(thisFile$, 1) = "/" Then
    GetFileOnly$ = ""

'**Path and file name**********************************
ElseIf InStr(1, thisFile$, "\") Or InStr(1, thisFile$, "/") Then
    thisSlash = InStr(1, thisFile$, "\")
    While thisSlash <> 0
        lastSlash = thisSlash
        thisSlash = InStr(lastSlash + 1, thisFile$, "\")
    Wend
    lastBackslash = lastSlash
    thisSlash = InStr(1, thisFile$, "/")
    While thisSlash <> 0
        lastSlash = thisSlash
        thisSlash = InStr(lastSlash + 1, thisFile$, "/")
    Wend
    If lastBackslash > lastSlash Then lastSlash = lastBackslash
    GetFileOnly$ = Mid$(thisFile$, lastSlash + 1)

'**Drive spec only**************************************
ElseIf Len(thisFile$) < 3 And InStr(1, thisFile$, ":") Then
    GetFileOnly$ = ""

'**Drive spec and file name*****************************
ElseIf InStr(1, thisFile$, ":") And Len(thisFile$) > 2 Then
    GetFileOnly$ = Mid$(thisPath$, 3)

'**Seems to be a file only*****************************
Else
    GetFileOnly$ = thisFile$

End If

End Function


Function GetPathOnly$(ByVal thisFile$)
Dim thisSlash As Integer
Dim forwardSlash As Integer
Dim backSlash As Integer
Dim lastSlash As Integer
Dim thisPath$

'**Path only********************************************
If Right$(thisFile$, 1) = "\" Or Right$(thisFile$, 1) = "/" Then
    If Len(thisFile$) = 1 Then
        thisPath$ = ""
    Else
        thisPath$ = Left$(thisFile$, Len(thisFile$) - 1)
    End If

'**Path and file name***********************************
ElseIf InStr(1, thisFile$, "\") Or InStr(1, thisFile$, "/") Then
    forwardSlash = InStr(1, thisFile$, "/")
    backSlash = InStr(1, thisFile$, "\")
    If backSlash > forwardSlash Then
        thisSlash = backSlash
    Else
        thisSlash = forwardSlash
    End If
    While thisSlash <> 0
        lastSlash = thisSlash
        forwardSlash = InStr(lastSlash + 1, thisFile$, "/")
        backSlash = InStr(lastSlash + 1, thisFile$, "\")
        If backSlash > forwardSlash Then
            thisSlash = backSlash
        Else
            thisSlash = forwardSlash
        End If
    Wend
    thisPath$ = Left$(thisFile$, lastSlash - 1)

'**Only one character - assume drive designation*******
ElseIf Len(thisFile$) = 1 Then
    If Asc(thisFile$) > 64 And Asc(thisFile$) < 91 Or Asc(thisFile$) > 96 And Asc(thisFile$) < 123 Then
        thisPath$ = thisFile$ + ":\"
    Else
        thisPath$ = ""
    End If

'**No backslash, but drive spec found******************
ElseIf InStr(1, thisFile$, ":") Then
    If Len(thisFile$) > 2 Then
        If Len(thisFile$) > InStr(1, thisFile$, ":") Then thisPath$ = Left$(thisFile$, InStr(1, thisFile$, ":")) + "\"
    ElseIf Len(thisFile$) = 2 Then
        thisPath$ = thisFile$ + "\"
    ElseIf Len(thisFile$) = 1 Then
        thisPath$ = ""
    Else
        thisPath$ = ""
    End If

'**Seems to be a file only*****************************
Else
    thisPath$ = ""

End If

'**make sure that drive ":" is properly positioned*****
If InStr(1, thisPath$, ":") Then
    '**If this is just a drive letter and colon, add a backslash
    If Len(thisPath$) = InStr(1, thisPath$, ":") Then thisPath$ = thisPath$ + "\"
    If Mid$(thisPath$, 3, 1) <> "\" And Mid$(thisPath$, 3, 1) <> "/" Then thisPath$ = Left$(thisPath$, 2) & "\" & Mid$(thisPath$, 3)
Else
    If Len(thisPath$) = 1 Then thisPath$ = thisPath$ + ":\"
    'If Len(thispath$) > 0 And Left$(thispath$, 1) <> "\" Then thispath$ = "\" + thispath$
End If

GetPathOnly$ = LCase$(thisPath$)

End Function

Function CheckPath$(ByVal thisPath$)
'**This guarantees a drive designatiion plus "correct" path. It doesn't
'**check to see if the path actually exists or is accessible
Dim curDrive$
Dim tempPath$

tempPath$ = Trim$(thisPath$)

If Len(tempPath$) = 1 Then
    tempPath$ = tempPath$ & ":\"
ElseIf Len(tempPath$) = 2 And Right$(tempPath$, 1) = ":" Then
    tempPath$ = tempPath$ & "\"
ElseIf Len(tempPath$) > 1 And InStr(1, tempPath$, ":") Then
    If InStr(1, tempPath$, ":") = 1 Then tempPath$ = "c" & tempPath$
    If InStr(1, tempPath$, ":") > 2 Then tempPath$ = Mid$(tempPath$, InStr(1, tempPath$, ":") - 1)
ElseIf Len(tempPath$) > 1 Then
    '**No drive designation. Add current drive to the front of the path.
    curDrive$ = CurDir$
    If Len(curDrive$) = 1 Then
        curDrive$ = curDrive$ & ":"
    ElseIf Len(curDrive$) >= 3 Then
        curDrive$ = Left$(curDrive$, 2)
    End If
    If Left$(tempPath$, 1) <> "\" Then
        tempPath$ = "\" & tempPath$
    End If
    tempPath$ = curDrive$ & tempPath$
End If

If Right$(tempPath$, 1) <> "\" Then tempPath$ = tempPath$ & "\"

CheckPath$ = tempPath$

End Function


Public Function IsDrive(ByVal thisDrive$)
'*********************************************************************
'**Checks to see if the drive is there and available.
'**A positive return means the drive is available.
'**A negative return is the error message passed by the system.
'*********************************************************************
Dim oldDrive$
Dim oldErrorMode&

oldErrorMode& = SetErrorMode(SEM_FAILCRITICALERRORS)
IsDrive = 0
oldDrive$ = thisDrive$
On Error Resume Next
ChDrive thisDrive$
Select Case Err
    Case 68 'Device unavailable
        IsDrive = -68
    Case 71 'Disk not ready
        IsDrive = -71
    Case 5 'Illegal function call
        IsDrive = -5
    Case Else
        ChDrive$ oldDrive$
        IsDrive = 1
End Select
oldErrorMode& = SetErrorMode(oldErrorMode&)
On Error GoTo 0

End Function

