Attribute VB_Name = "modMain"
Private hHelp As New HTMLHelp

Public Function GetWinHelpFile$(section$)

Dim appName$
Dim hlpFile$
Dim hlpWindow$
Dim success As Integer
Dim retval As String * 256

GetWinHelpFile$ = ""

'**See if there is a Help file name for this form*********************
success = GetPrivateProfileString("WinHelpFile", section$, "", retval, Len(retval), dataFile$)
hlpFile$ = Left(retval, success)
If hlpFile$ = "" Then
    '**No Help file name for this window. See if file contains a default.
    success = GetPrivateProfileString("WinHelpFile", "default", "", retval, Len(retval), dataFile$)
    hlpFile$ = Left(retval, success)
    If hlpFile$ = "" Then
        '**No default in file. Go to ultimate default (EXEName + .hlp).
        hlpFile$ = App.EXEName & ".hlp"
    End If
End If
hlpFile$ = AddFile$(App.Path, hlpFile$)

'**See if there is a Help window name for this form*******************
success = GetPrivateProfileString("WinHelpWindow", section$, "", retval, Len(retval), dataFile$)
hlpWindow$ = Left(retval, success)
If hlpWindow$ = "" Then
    '**No Help file name for this window. See if file contains a default.
    success = GetPrivateProfileString("WinHelpWindow", "default", "", retval, Len(retval), dataFile$)
    hlpWindow$ = Left(retval, success)
    '**Note, the ultimate default window is "main", for which you don't
    '**need to specify a window name.
End If

If hlpWindow$ = "" Then
    GetWinHelpFile$ = hlpFile$
Else
    GetWinHelpFile$ = hlpFile$ & ">" & hlpWindow$
End If

End Function

Public Function GetHTMLHelpFile$(section$)

Dim appName$
Dim hlpFile$
Dim success As Integer
Dim retval As String * 256

GetHTMLHelpFile$ = ""

'**See if there is a Help file name for this form*********************
success = GetPrivateProfileString("HTMLHelpFile", section$, "", retval, Len(retval), dataFile$)
hlpFile$ = Left(retval, success)
If hlpFile$ = "" Then
    '**No Help file name for this window. See if file contains a default.
    success = GetPrivateProfileString("HTMLHelpFile", "default", "", retval, Len(retval), dataFile$)
    hlpFile$ = Left(retval, success)
    If hlpFile$ = "" Then
        '**No default in file. Go to ultimate default (EXEName + .hlp).
        hlpFile$ = App.EXEName & ".hlp"
    End If
End If
GetHTMLHelpFile$ = AddFile$(App.Path, hlpFile$)

End Function

Public Function GetHTMLHelpWindow$(section$)

Dim hlpWindow$
Dim success As Integer
Dim retval As String * 256

GetHTMLHelpWindow$ = ""

'**See if there is a Help window name for this form*******************
success = GetPrivateProfileString("HTMLHelpWindow", section$, "", retval, Len(retval), dataFile$)
hlpWindow$ = Left(retval, success)
If hlpWindow$ = "" Then
    '**No Help file name for this window. See if file contains a default.
    success = GetPrivateProfileString("HTMLHelpWindow", "default", "", retval, Len(retval), dataFile$)
    GetHTMLHelpWindow$ = Left(retval, success)
    '**Note, the ultimate default window is "main", for which you don't
    '**need to specify a window name.
End If

End Function

Public Sub MainWindowOnHelp(thisForm As Form, hwndControl As Long, iCtrlId As Long, mouseX As Long, mouseY As Long)

Dim fControl As Control
Dim i As Integer
Dim j As Integer
Dim hwndMainMenu&
Dim menuItemCount&
Dim hwndSubMenu&
Dim dwTopicID&

'**Set topic ID to zero. Later, if it hasn't changed and we are not
'**in WhatsThisHelp mode we will open that topic in a popup window.
dwTopicID& = 0
If IsMenu(hwndControl) <> 0 And iCtrlId = 0 Then
    '**This is a main menu item. Compare against main menu hWnds.
    hwndMainMenu& = GetMenu(frmMain.hWnd)
    menuItemCount& = GetMenuItemCount(hwndMainMenu&)
    '**Note: how much to subtract from menuItemCount& in the following
    '**loop depends on which toolbar items are activated.
    '**If you have a system menu (item 0), minimize, maximize,
    '**and close items, which are all part of the menu count, then use
    '**menuItemCount% - 4.
    For i = 1 To menuItemCount& - 4
        hwndSubMenu& = GetSubMenu(hwndMainMenu&, i)
        If hwndSubMenu& = hwndControl Then
            success = GetMenuString(hwndMainMenu&, i, retval, Len(retval), MF_BYPOSITION)
            dwTopicID& = GetMenuTopicID&(frmMain, Left(retval, success))
            Call OpenHelpTopic(thisForm, dwTopicID&)
            Exit For
        End If
    Next i
    
ElseIf IsMenu(hwndControl) <> 0 And iCtrlId <> 0 Then
    '**This is a sub menu item. Now we need to compare control IDs.
    menuItemCount& = GetMenuItemCount(hwndControl)
    For i = 0 To menuItemCount& - 1
        If GetMenuItemID(hwndControl, i) = iCtrlId Then
            success = GetMenuString(hwndControl, i, retval, Len(retval), MF_BYPOSITION)
            dwTopicID& = GetMenuTopicID&(frmMain, Left(retval, success))
            Call OpenHelpTopic(thisForm, dwTopicID&)
            Exit For
        End If
    Next i

'ElseIf thisForm.hWnd = hWndControl Then
    '**Requested Help for form
'    GetTopicID& = thisForm.HelpContextID
    
Else

    '**Requested Help for some other control
    Dim winHandle&
    winHandle& = WindowFromPoint(mouseX, mouseY)
    '**Find the current control and it's WhatsThisHelpID.
    '**You need to loop through all of the forms that might be floating
    '**around.
    dwTopicID& = FindControlTopicID&(frmMain, winHandle&)
    If dwTopicID& = 0 Then
        dwTopicID& = FindControlTopicID&(frmChild1, winHandle&)
        If dwTopicID& = 0 And frmMain.mnu_ColorTool.Checked <> 0 Then
            '**Only do this loop if the tool is open.
            dwTopicID& = FindControlTopicID&(frmTool1, winHandle&)

        End If
    End If

    'See if we found a topic ID.
    If dwTopicID& = 0 Then
        '**If not, go to the topic ID for the dialog box.
        dwTopicID& = frmMain.HelpContextID
    End If

    '**Otherwise, see exactly what we have to show.
    If frmChild1.Text1.hWnd = winHandle& Then
        '**The control is the text box.
        If frmChild1.Text1.selText = "" Then
            Call OpenHelpTopic(thisForm, dwTopicID&)
        Else
            Call OpenHelpWithKey(thisForm, frmChild1.Text1.selText)
        End If
        
    ElseIf winHandle& = hwndControl Then
        '**Mouse pointer is currently over the conntrol.
        '**This overrides the text selection
        Call OpenHelpTopic(thisForm, dwTopicID&)
    
    ElseIf frmChild1.Text1.selText = "" Then
        '**Text selection is blank. Use dwTopicID&
        Call OpenHelpTopic(thisForm, dwTopicID&)
        
    ElseIf frmChild1.Text1.selText <> "" Then
        '**We are not on the control and there is a text selection.
        '**Use the text selection as a keyword.
        Call OpenHelpWithKey(thisForm, frmChild1.Text1.selText)
        
    End If
    
End If

End Sub

Public Sub DialogBoxOnHelp(thisForm As Form, hwndControl As Long, iCtrlId As Long, mouseX As Long, mouseY As Long)

Dim fControl As Control
Dim i As Integer
Dim j As Integer
Dim hwndMainMenu&
Dim menuItemCount&
Dim hwndSubMenu&
Dim dwTopicID&

dwTopicID& = 0
Dim winHandle&
winHandle& = WindowFromPoint(mouseX, mouseY)
'**Find the current control and it's WhatsThisHelpID.
'**You need to loop through all of the forms that might be floating
'**around.
dwTopicID& = FindControlTopicID&(thisForm, winHandle&)
'See if we found a topic ID.
If dwTopicID& = 0 Then
    '**If not, go to the topic ID for the dialog box.
    dwTopicID& = thisForm.HelpContextID
End If
If dwTopicID& <> 0 Then Call OpenHelpTopic(thisForm, dwTopicID&)

End Sub

Public Function GetMenuTopicID&(thisForm As Form, menuCaption$)
'**This subroutine uses the menu item string form API calls
'**and the control caption from VB calls to match the current main
'**menu item as determined through API calls with a menu item
'**in VB. There is no way in VB to find the currently selected
'**menu item, and main menu items return a control ID of zero, so we
'**can't use the control ID as we can with sub menu items.
GetMenuTopicID& = 0
For Each Control In thisForm.Controls
    If LCase$(TypeName(Control)) = "menu" Then
        If Control.Caption = menuCaption$ Then
            GetMenuTopicID& = Control.HelpContextID
            Exit For
        End If
    End If
Next Control

End Function

Public Sub OpenHelpTopic(thisForm As Form, topicNumber&)

'MsgBox "Call Help Topic " & Str$(topicNumber&) & " from Help file " & curHelpFile$
If topicNumber& = 1 Then  'Request for Contents tab
    If useHTMLFormLevelHelp% = 0 Then
        '**Open the Help Topics dialog box to the Contents sheet
        success = WinHelp(frmMain.hWnd, GetWinHelpFile$(thisForm.Name), HELP_COMMAND, ByVal "Contents()")
        '**Open the Help Topics dialog box to the last used tab.
        'success = WinHelp(frmMain.hWnd, GetWinHelpFile$(thisForm.Name), HELP_FINDER, ByVal 0&)
    Else
        With hHelp
          .CHMFile = GetHTMLHelpFile$(thisForm.Name)
          .HHWindow = "Main"
          .HHDisplayContents
        End With
    End If
    
ElseIf topicNumber& = 2 Then  'Request for Index tab
    If useHTMLFormLevelHelp% = 0 Then
        success = WinHelp(frmMain.hWnd, GetWinHelpFile$(thisForm.Name), HELP_PARTIALKEY, ByVal "")
    Else
        With hHelp
          .CHMFile = GetHTMLHelpFile$(thisForm.Name)
          .HHWindow = "Main"
          .HHDisplayIndex
        End With
    End If

ElseIf topicNumber& < 10000 Then
    If useHTMLFormLevelHelp% = 0 Then
        'MsgBox "WinHelp Secondary Window"
        success = WinHelp(frmMain.hWnd, GetWinHelpFile$(thisForm.Name), HELP_CONTEXT, ByVal topicNumber&)
    Else
        'MsgBox "HTMLHelp Tri-pane"
        With hHelp
          .CHMFile = GetHTMLHelpFile$(thisForm.Name)
          .HHTopicID = topicNumber&
          .HHWindow = GetHTMLHelpWindow$(thisForm.Name)
          .HHDisplayTopicID
        End With
    End If
ElseIf topicNumber < 20000 Then
    '**This is a request for training card Help.
    success = WinHelp(thisForm.hWnd, GetWinHelpFile$("Training Cards"), HELP_TCARD Or HELP_CONTEXT, ByVal topicNumber&)
    Set currentTCCallingWindow = thisForm
    frmMain.Timer2.Enabled = 1
    
Else
    If useHTMLPopups% = 0 Then
        'MsgBox "WinHelp Popup"
        success = WinHelp(frmMain.hWnd, GetWinHelpFile$(thisForm.Name), HELP_CONTEXTPOPUP, ByVal topicNumber&)
    Else
        'MsgBox "HTMLHelp Popup"
        With hHelp
          .HHPopupType = HH_CHM_POPUP
          .CHMFile = GetHTMLHelpFile$(thisForm.Name)
          .HHPopupFile = "popups.txt"
          .HHPopupID = topicNumber&
          .HHPopupCustomColors = False
          .HHPopupBackColor = vbBlack
          .HHPopupTextColor = vbWhite
          .HHPopupTextFont = "Arial"
          .HHPopupTextSize = "9"
          .HHPopupTextBold = False
          .HHPopupTextItalic = False
          .HHPopupTextUnderline = False
          .HHDisplayPopup thisForm.hWnd
        End With
        success = BringWindowToTop(frmMain.hWnd)
    End If
End If

End Sub

Public Sub OpenHelpWithKey(thisForm As Form, keyWord$)

Dim selText$
'**Eliminate punctuation and spaces from the ends of the keyword*********
selText$ = Trim$(keyWord$)
While Asc(Right$(selText$, 1)) > 122 Or Asc(Right$(selText$, 1)) < 48 Or (Asc(Right$(selText$, 1)) > 57 And Asc(Right$(selText$, 1)) < 65) Or (Asc(Right$(selText$, 1)) > 90 And Asc(Right$(selText$, 1)) < 96)
    selText$ = Left$(selText$, Len(selText$) - 1)
Wend

If useHTMLFormLevelHelp% = 0 Then
    'MsgBox "Open Help with keyword " & keyWord$ & " from Help file " & curHelpFile$
    '**Force the Help file open. This is necessary to insure that the
    '**HELP_COMMAND command always work. The Help file is forced open
    '**to the default topic, which is the "Keyword Not Found" topic
    '**In the same secondary window that is normally used.
    success = WinHelp(frmMain.hWnd, GetWinHelpFile$(thisForm.Name), HELP_FORCEFILE, ByVal 0&)
    
    '**Set up the string for calling the KLink macro. We first need
    '**to use the TestKLink macro to see if there is a matching
    '**keyword. Note that the Help compiler converts KLink to KL
    '**TestKLink to KL with the test parameter. Since this string
    '**is not going throught the Help compiler, we need to do the
    '**conversion in the string.
    HelpCommand$ = "IF(KL(`" & selText$ & "', 4, `', `'),`KL(`" & selText$ & "', 1, `', `')')"
    
    '**Call the TestKLink macro and KLink macros.
    success = WinHelp(frmMain.hWnd, GetWinHelpFile$(thisForm.Name), HELP_COMMAND, ByVal HelpCommand$)
Else
    With hHelp
        .CHMFile = GetHTMLHelpFile$(thisForm.Name)
        .HHDefaultURL = vbNullString
        .HHMsgTitle = vbNullString
        .HHMsgText = vbNullString
        .HHWindow = "Main"
        .HHKeyword = selText$
        .HHDisplayKeyword
    End With

End If
End Sub

Public Function FindControlTopicID&(thisForm As Form, hwndControl As Long)
'**This subroutine simply looks for the control specified by hwndControl&
'**on the selected form and returns the WhatsThisHelpID for that control
'**if it's found.
FindControlTopicID& = 0
For Each Control In thisForm.Controls
    If LCase$(TypeName(Control)) = "menu" Or LCase$(TypeName(Control)) = "image" Or LCase$(TypeName(Control)) = "label" Or LCase$(TypeName(Control)) = "timer" Then
        '**Control types to ignore.
        '**These control types do not an have hWnd property.
        '**Add additional controls as needed per project.
    Else
        '**Loop through all the valid controls to find a match.
        If hwndControl = Control.hWnd Then
            FindControlTopicID& = Val(Control.WhatsThisHelpID)
            Exit For
        End If
    End If
Next Control

End Function

Public Sub RightClickPopupHelp(thisForm As Form, hwndControl As Long)
'**OnContextMenu function seems to get the control ID for the next
'**container up, not the actual control you click on.

'**This subroutine automatically pops up Help when you right click a
'**Control.
Dim topicID&
Dim winHandle&

Dim cPoint As POINTAPI
success = GetCursorPos(cPoint)

'**Find the control we are over**************************************
winHandle& = WindowFromPoint(cPoint.x, cPoint.y)

'**See if you can find the control that belongs to this hWnd*********
topicID& = FindControlTopicID&(thisForm, winHandle&)

'**If no control found, see if we can get a topic ID from the form***
If topicID& = 0 Then
    topicID& = thisForm.HelpContextID
End If

'**If there is a topic ID, call the appropriate Help*****************
Call OpenHelpTopic(thisForm, topicID&)

End Sub
